# Simulation of Backscattered light

This script generate simulation data to retrieve fraction of backscattered light
in the Virgo interferometer by scatterers.

## Getting started

This project use [uv](https://docs.astral.sh/uv/) to manage
dependencies, and [mise](https://mise.jdx.dev/) to manage python
version and virtual environment.

> [!NOTE]
> You can still use pip to manage dependencies using [pyproject.toml](pyproject.toml)

Once the dependencies are installed, run `python main.py -h` to get help.

## Example

```sh
python main.py --filename=test.hdf5\
               --laser-power=20\
               --dark-fringe=8e-3\
               --sr-rotation=0\
               --max-tem=0\
               --precision=100\
               --name="This is a test"
```

## Dependencies

- [Finesse][finesse]: to compute the simulation
- [backscattering_simulation_data][bsd]: to store the result
- [gitpython][gitpython]: to get data about the current git repo
- [gwpy][gwpy]: to use normalized FrequencySeries and units
- [h5py][h5py]: to specify where to store the result
- [rich][rich]: to have pretty printing

## Development dependencies

- [basedpyright][basedpyright]: to catch typing and miscellaneous error
- [ruff][ruff]: to lint and format the code

## License

This project is licensed under the GNU GPL v3+. See [license file](LICENSE) for
more information.

## Acknowledgment

Thanks to all the people that worked on the libraries, and on all software and
libraries used in this project.

[finesse]: https://finesse.ifosim.org
[bsd]: https://git.ligo.org/augustin.demagny/backscattering_simulation_data
[gitpython]: https://gitpython.readthedocs.io/
[gwpy]: https://gwpy.github.io/
[h5py]: https://docs.h5py.org/
[rich]: https://rich.readthedocs.io/
[basedpyright]: https://docs.basedpyright.com
[ruff]: https://docs.astral.sh/ruff/
